VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Condition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public name As String
Public Argumento As String
Public Activa As Boolean

'local variable(s) to hold property value(s)
Private mvarTipo As String 'local copy
' En esta lista, guarda subcondiciones, por si es una condicin "o" o "y"
Private subcondiciones As Collection

Public Function Evaluate(Msg As Object) As Boolean
Attribute Evaluate.VB_UserMemId = 0
'  Dim m As Outlook.MailItem
  On Error Resume Next
  Evaluate = False
  Select Case mvarTipo
  Case "Asunto"
    Evaluate = checkStr(Msg.Subject, Argumento)
  Case "Texto"
    Evaluate = checkStr(Msg.Body, Argumento)
  Case "De"
  ' ToDo: Evaluar la direccin, no el nombre del remitente
    Evaluate = checkStr(Msg.SenderName, Argumento)
  Case "Para"
    Evaluate = checkList(Msg.Recipients, Argumento)
  Case "CC"
    Evaluate = checkList(Msg.CC, Argumento) Or checkStr(Msg.BCC, Argumento)
  Case "Categoria"
    Evaluate = checkStr(Msg.Categories, Argumento)
  Case "Carpeta"
    Evaluate = checkStr(Msg.Folder, Argumento)
  Case "OR"
    Evaluate = evaluate_alguna_cierta(Msg)
  Case "AND"
    Evaluate = evaluate_todas_ciertas(Msg)
  Case "NUNCA"
    Evaluate = False
  Case "SIEMPRE"
    Evaluate = True
  Case Else
    MsgBox "Tipo de condicion desconocido " & mvarTipo
  End Select
End Function

Function evaluate_alguna_cierta(Msg As Object) As Boolean
  Dim c As Condition
  For Each c In subcondiciones
    If c.Evaluate(Msg) Then
      evaluate_alguna_cierta = True
      Exit Function
    End If
  Next
  evaluate_alguna_cierta = False
End Function

Function evaluate_todas_ciertas(Msg As Object) As Boolean
  Dim c As Condition
  For Each c In subcondiciones
    If c.Evaluate(Msg) = False Then
      evaluate_todas_ciertas = False
      Exit Function
    End If
  Next
  evaluate_todas_ciertas = True
End Function

Public Sub Load(att As Outlook.PostItem)
  name = att.Subject
  Argumento = att.Body
  Tipo = att.UserProperties("Condicion")
  If mvarTipo = "AND" Or mvarTipo = "OR" Then
    Set subcondiciones = New Collection
    Dim m1 As MAPI.Message
    Dim subatt As MAPI.Attachment
    Dim subatt2 As Outlook.PostItem
    Set m1 = MsgOutlook2MAPI(att)
    For Each subatt In m1.Attachments
      'Set att = a1
      Set subatt2 = AttMAPI2Outlook(subatt)
      Select Case subatt2.MessageClass
      Case "IPM.Post.Ruler.Condition"
        Dim cond As New Condition
        cond.Load subatt2
        subcondiciones.Add cond
'      Case "IPM.Post.Ruler.Action"
'        Dim act As New Action
'        act.Load att2
'        acciones.Add act
  
      Case Else
        MsgBox "Clase de anexo desconocida:" & subatt2.MessageClass & " en condicion " & name
      End Select
    Next
  End If
  ' TODO: Activa
  Activa = True
End Sub
Public Sub LoadObsoleto(Folder As String, iName As String)
  Dim s As String
  Dim sep As Integer
  Dim auxTipo As String
  ' Establecemos propiedades a partir de parmetros
  name = iName
  ' Leemos la condicin desde el registro
  s = GetSetting(app.Title, "Rules_" & Folder, "Cond_" & iName, "NUNCA|")
  ' podemos tener un primer carcter que indica que la propiedad est desactivada
  If Left(s, 1) = "*" Then
    s = Mid(s, 2)
    Activa = False
  Else
    Activa = True
  End If
  ' separamos sus campos, tipo|Argumento
  split s, "|", auxTipo, Argumento
  Tipo = auxTipo
  If Tipo = "y" Or Tipo = "o" Then
    Set subcondiciones = New Collection
    load_cond_listObsoleto subcondiciones, Folder, Argumento
  End If
End Sub

Public Sub Save(Folder As String)
  Dim s As String
  
  s = Tipo & "|" & Argumento
  ' "*" indicador de inactivo delante de la cadena
  If Activa = False Then
    s = "*" & s
  End If
  SaveSetting app.Title, "Rules_" & Folder, "cond_" & name, s
End Sub


Public Property Let Tipo(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Tipo = 5
    mvarTipo = vData
End Property


Public Property Get Tipo() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Tipo
    Tipo = mvarTipo
End Property
