Attribute VB_Name = "ModuleReglas"
Option Explicit

Global reglas As New Collection

Public Sub Load_reglas()
  Dim f As Outlook.MAPIFolder
  Set f = get_rules_folder
  Load_rules f
End Sub

Private Function get_rules_folder() As Outlook.MAPIFolder
  On Error Resume Next
  Const RULE_FOLDER_NAME As String = "Outlook Ruler"
  Dim folderInbox As Outlook.MAPIFolder
  
  Set folderInbox = olApp.GetDefaultFolder(olFolderInbox)
  Set get_rules_folder = folderInbox.Folders(RULE_FOLDER_NAME)
  If Err.Number <> 0 Then
    Err.Clear
    Set get_rules_folder = folderInbox.Folders.Add(RULE_FOLDER_NAME)
    MsgBox "Se cre la carpeta Outlook Ruler"
    RegistraForm "Action.oft", get_rules_folder
    RegistraForm "Condition.oft", get_rules_folder
    RegistraForm "Rule.oft", get_rules_folder
  End If
'  Dim foldername As String
'  foldername = GetSetting(app.Title, "Rules", "RulesFolder", "\Bandeja de Entrada\Outlook Ruler")
'  Set get_rules_folder = OpenMAPIFolder(foldername)
  
End Function

' Registra un form en una carpeta, dado un fichero .oft con su descripcin
' Adaptado de una pagina Web de MARK G. WISNIEWSKI (mark.wisniewski@worldnet.att.net)

Private Sub RegistraForm(template As String, f As Outlook.MAPIFolder)
  Dim auxform As Outlook.PostItem
  Dim Form As Outlook.FormDescription
  Set auxform = olApp.Application.CreateItemFromTemplate(app.Path & "\" & template, f)
  Set Form = auxform.FormDescription
  Form.PublishForm olFolderRegistry, f
  'form.name = "Action"
  Set Form = Nothing
  Set auxform = Nothing
End Sub
'Lee todas las reglas contenidas en una carpeta que le pasamos
Private Sub Load_rules(ruleFolder As Outlook.MAPIFolder)
  Dim r As Outlook.PostItem
  Dim s As Rule
  prepareIDconversion ruleFolder
  For Each r In ruleFolder.Items
    If r.MessageClass = "IPM.Post.Ruler.Rule" Then
      Set s = New Rule
      s.Load r
      reglas.Add s
    End If
  Next
End Sub

' Lee una lista de reglas separadas por blancos
'Private Sub load_rule_list(ruleFolder As String, ruleList As String)
'  Dim aRuleName As String
'  Dim r As Rule
'  Do While ruleList <> ""
'    split ruleList, " ", aRuleName, ruleList
'    Set r = New Rule
'    r.Load ruleFolder, aRuleName
'    reglas.Add r
'  Loop
'End Sub

Public Function checkStr(text As String, subtext As String) As Boolean
  If InStr(1, text, subtext) = 0 Then
    checkStr = False
  Else
    checkStr = True
  End If
End Function

Public Function checkList(list As Object, subtext As String) As Boolean
  Dim text As Object
  checkList = False
  For Each text In list
    If InStr(1, text, subtext) <> 0 Then
      checkList = True
      Exit Function
    End If
  Next
End Function


' Funcin tomada de una pgina Web.
' La pgina se llama FolderByName.htm, pero no recuerdo el servidor
'
' Function to walk a path to open an Outlook folder
'
' Dim flr As Outlook.MAPIFolder
' Set flr = OpenMAPIFolder("\Microsoft Mail Shared Folders\SharedFolder\Contacts")

'
' This routine does the following generically:
' Set ns = app.GetNamespace("MAPI")
' Set flr = ns.Folders("Microsoft Mail Shared Folders")
' Set flr = flr.Folders("Shared Folder")
' Set flr = flr.Folders("Contacts")
'

Function OpenMAPIFolder(ByVal szPath As String) As Outlook.MAPIFolder

  Dim app As New Outlook.Application
  'Dim ns As Outlook.NameSpace
  Dim flr As Outlook.MAPIFolder
  Dim szDir As String
  Dim i As Long
  Const Application_pathSeparator = "\"
  
  
  If Left(szPath, Len(Application_pathSeparator)) = Application_pathSeparator Then
    szPath = Mid(szPath, Len(Application_pathSeparator) + 1)
  Else
    Set flr = app.ActiveExplorer.CurrentFolder
  End If
  
  While szPath <> ""
    i = InStr(szPath, Application_pathSeparator)
  
    If i Then
      szDir = Left(szPath, i - 1)
      szPath = Mid(szPath, i + Len(Application_pathSeparator))
    Else
      szDir = szPath
      szPath = ""
    End If
  
    If flr Is Nothing Then
'      Set ns = app.GetNamespace("MAPI")
'      Set flr = ns.Folders(szDir)
      Set flr = olApp.Folders(szDir)
    Else
      Set flr = flr.Folders(szDir)
    End If
  
  Wend
  
  Set OpenMAPIFolder = flr
End Function


' Lee una lista de condiciones separadas por blancos
Public Sub load_cond_listObsoleto(condiciones As Collection, condFolder As String, condlist As String)
  Dim aCondName As String
  Dim c As Condition
  Do While condlist <> ""
    split condlist, " ", aCondName, condlist
    Set c = New Condition
    c.LoadObsoleto condFolder, aCondName
    condiciones.Add c
  Loop
End Sub



